#!/usr/bin/python

import subprocess
import web
import netifaces
import os
import sys


# SETTINGS ====================================================================
truecrypt_cmd = "/usr/bin/truecrypt"

opensecurity_urls = (
    '/password',                'os_password'
)

class os_password:
    
    # delete the key file in a secure way (will not working on ssd's :/ ,but ram only vm -> should be ok)
    def deleteKeyfile(self, keyfilepath):
        filesize = os.path.getsize(keyfilepath)
        keyfile = open (keyfilepath, "wr+")
        for i in range (0, 10):
            keyfile.seek(0)
            keyfile.write(os.urandom(filesize))
            keyfile.flush()
        keyfile.close()
        os.remove(keyfilepath)
    
    
    def GET(self, settings):
        return self.POST()
    
    def POST(self, settings):
        
        # pick the arguments
        args = web.input()
                      
        if not "password" in args:
            raise web.badrequest()

        if "keyfile" in args:
            keyfile = open (settings["keyfilepath"], "rw+")
            keyfile.write(args["keyfile"])
            keyfile.close()
            command = [settings["script"], settings["device"], settings["mountpoint"], args["password"], settings["keyfilepath"]]
        else:
            command = [settings["script"], settings["device"], settings["mountpoint"], args["password"]]
            
        process = subprocess.Popen( command, stdout=subprocess.PIPE, stderr=subprocess.PIPE )
        retval = process.wait()
        ( stdout, stderr ) = process.communicate()
        
        if "keyfile" in args:
            self.deleteKeyfile(settings["keyfilepath"])
        
        if (retval != 0):
            raise web.badrequest(stderr)
        
        return "Success: Encrypted Stick is mounted"

class MyRestListener(web.application):
    def __init__(self, mapping=(), fvars={}, autoreload=None, script=None, device=None, mountpoint=None, tries=None, keyfilepath=None):
        web.application.__init__(self, mapping, fvars, autoreload)
        self.device = device
        self.mountpoint = mountpoint
        self.script = script
        self.tries = tries
        self.keyfilepath = keyfilepath
        
    def run(self, interface, port, *middleware):
        func = self.wsgifunc(*middleware)
        ifaceip = netifaces.ifaddresses(interface)[2][0]["addr"]
        return web.httpserver.runsimple(func, (ifaceip, port))
    
    def handle(self):
        fn, args = self._match(self.mapping, web.ctx.path)
        args.append({"script": self.script, "device": self.device, "mountpoint": self.mountpoint, "tries": self.tries, "keyfilepath": self.keyfilepath})
        return self._delegate(fn, self.fvars, args)
